#include <stdio.h>
#include "pvm3.h"
#define ERR				-1
#define OK				0
#define NB_PROC		5
#define SEND_TAG	0
#define RECV_TAG	1
#define FROM_ALL	-1
#define SLAVE		"slave"

int main(int argc, char** argv) {
	int tids[NB_PROC];				/* Liste des esclaves */
	int val;									/* Valeur a envoyer */
	struct pvmhostinfo *host;	/* Machine hebergeant le maitre */
	int nhost, narch, nb;
	int bufId, size, tag, id;
	
	pvm_config(&nhost, &narch, &host);

	nb = pvm_spawn(SLAVE, (char **)0, PvmTaskDefault, host->hi_name,
		NB_PROC, tids);
	
	if (nb != NB_PROC) {
  	pvm_exit();
		return ERR;
	}
  
	for (nb=0; nb<NB_PROC; nb++) {
		val = nb+1;
  	pvm_initsend(PvmDataDefault);
		printf("Envoi de %d a %d.\n", val, tids[nb]);
		pvm_pkint(&val, 1, 1);
		pvm_send(tids[nb], SEND_TAG);
  }
	
	for (nb=0; nb<NB_PROC; nb++) {
		bufId = pvm_recv(FROM_ALL, RECV_TAG);
		if (bufId < 0) {
			pvm_exit();
			return ERR;
		}
		
		/*
		 * Decodage des informations du message recu
		 */
		if (pvm_bufinfo(bufId, &size, &tag, &id) < 0) {
			pvm_exit();
			return ERR;
		}
	
		pvm_upkint(&val, 1, 1);
		printf("J'ai recu %d de la part de %d.\n", val, id);
	}

	pvm_exit();
	return OK;
}
