#include <stdio.h>
#include "pvm3.h"
#define ERR				-1
#define OK				0
#define RECV_TAG	-1
#define SEND_TAG	1

int main(int argc, char **argv) {
	int masterId;	/* Identifiant du maitre */
	int selfId;		/* Identifiant du processus courant */
	int val;			/* Valeur recue */
	
	selfId = pvm_mytid();
	masterId = pvm_parent();
	
	/*
	 * Attente de reception d'un message quelconque emanant du maitre
	 * et portant un tag donne
	 * Si le tag vaut -1, alors tous les tags sont acceptes
	 */
	if (pvm_recv(masterId, RECV_TAG) < 0) {
		pvm_exit();
		return ERR;
	}
	
	/* 
	 * Reception de l'entier envoye par le maitre
	 */
	pvm_upkint(&val, 1, 1);
	pvm_initsend(PvmDataDefault);
	pvm_pkint(&val, 1, 1);
	if (pvm_send(masterId, SEND_TAG) < 0) {
		pvm_exit();
		return ERR;
	}
	
	pvm_exit();
	return OK;
}
